program BDDmpAll;
{$APPTYPE CONSOLE}
uses
  BorDebug, HVBorDebug, BorDebugScanners, BorDebugDumpScanner;

type
  TDumpToStdOut = class(TObject)
  public
    procedure OnScannerDump(Sender: TObject; const Msg: string);
  end;

procedure TDumpToStdOut.OnScannerDump(Sender: TObject; const Msg: string);
begin
  Write(Msg);
end;

var
  Debug: TBorDebug;
  DumpScanner: TDumpBorDebugScanner;
  DumpToStdOut: TDumpToStdOut;
begin
  Debug := nil;
  DumpToStdOut := nil;
  DumpScanner := nil;
  try
    Debug := TBorDebug.Create(ParamStr(1));
    DumpToStdOut := TDumpToStdOut.Create;
    DumpScanner := TDumpBorDebugScanner.Create(Debug);
    DumpScanner.OnDump := DumpToStdOut.OnScannerDump;

    DumpScanner.Scan([soModule, soAlignSym, soSrcModule, soGlobalSym, soGlobalPub,
      soGlobalTypes, soNames, soBrowse, soSrcModuleRanges, soSrcModuleFiles]);
  finally
    DumpScanner.Free;
    DumpToStdOut.Free;
    Debug.Free;
  end;
end.
